#include "interrupt.h"

struct List<IntConnected<void> > intConnecteds[256];

template <int level>
struct InterruptHandlers
{
	static void onInterrupt()
	{
		IntConnected<void> *cur, *next;

		cur=intConnecteds[level].head->next;
		while(next=cur->next)
		{
			//(cur->*onInterrupt)();
			//(cur->object)->*(cur->methode)();
			cur->call();
			cur=next;
		}
	}
	static void enable()
	{
		static U32 h;
		//onInterrupt();
		h=(U32)&InterruptHandlers::onInterrupt;
	}
};

struct Rtc: public IntConnected<Rtc>
{
	void onInterrupt();
};

void Rtc::onInterrupt()
{
}

Rtc rtc;

InterruptHandlers<8> it8;

int attach()
{
	it8.enable();

	rtc.methode=&Rtc::onInterrupt;
/*
	rtc.object=&rtc;
*/
	intConnecteds[8].add((IntConnected<void> *)&rtc);
}