#ifndef __SocketUdp_h__
#define __SocketUdp_h__

#include "ip.h"
#include "ethernet.h"
#include "ethernetCapable.h"

struct SocketUdp
{
	struct EndPoint
	{
		Ethernet::Address ethernet;
		Ip::Address ip;
		U16 port;
	};
	EthernetCapable *ec;
	EndPoint local,distant;

	SocketUdp();
	U32 send(const U8* data,U32 len);
	U32 recv(      U8* data,U32 len);
};


#endif /* __SocketUdp_h__ */
