#ifndef __tcp_h__
#define __tcp_h__

#include "type.h"

struct Tcp
{
	typedef U16 Port;
	Relative<Port, 0,Ube16> source;
	Relative<Port, 2,Ube16> destination;
	Relative<U32,  4,Ube32> seq;
	Relative<U32,  8,Ube32> ack;
	struct Flags
	{
		Field<U8, 0,4> dataOffset;
		Field<U8,10,1> urg;
		Field<U8,11,1> ack;
		Field<U8,12,1> psh;
		Field<U8,13,1> rst;
		Field<U8,14,1> syn;
		Field<U8,15,1> fin;
	}
	RelativeRef<Flags,12> flags;
	Relative<U16, 14,Ube16> window;
	Relative<U16, 16,Ube16> chksum;
	Relative<U16, 18,Ube16> urgentPointer;
	RelativeField<Ube16, 6,0,12> fragmentOffset;
	Relative<Ube16,2,Ube16> totalLength;
	Relative<U16,4,Ube16> identification;
};

#endif /* __tcp_h__ */
